package com.example.ellegadodepintia.exploradoresDePintia.model.efecto

import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo
import com.example.ellegadodepintia.exploradoresDePintia.model.GestorCombate
import com.example.ellegadodepintia.soundManager.SoundManager
class EfectoAtaqueProtagonista(probabilidadExito: Int) : Efecto(probabilidadExito) {
    private lateinit var soundManager: SoundManager
    override fun ejecutar(): String {
        val probabilidadPersonaje = (1..100).random()
        val mensaje: String
        soundManager = SoundManager(GameState.context!!)
        if (probabilidadPersonaje <= probabilidadExito) {
            GestorCombate.cargarAnimacionesAtaqueProtagonista()
            val ataqueReal = GestorCombate.calcularAtaque(GameState.jugador.atributos[Atributo.Ataque]!!, GameState.jugador.atributos[Atributo.Critico]!!)
            GameState.eventoActual.actualizarResistencia(-ataqueReal)
            mensaje = "¡Ataque realizado con éxito has hecho $ataqueReal de daño"
            soundManager.playSound(R.raw.sound_espada,100)
        } else {
            mensaje = "Has fallado el golpe, recibe 0 de daño"
            soundManager.playSound(R.raw.sound_miss,100)
        }
        return mensaje
    }
}